require 'json'
class Widget
    attr_accessor  :name
    attr_accessor  :description
    attr_accessor  :kind

  def initialize name: nil, description: nil, kind: nil
    self.name, self.description, self.kind =
    name, description, kind
   end

  def to_json(*a)
    hash = { 
      name: @name,
      description: @description,
      kind: @kind
    }
    hash.delete_if { |k, v| v.nil? || v.empty?  }
    hash.to_json(*a)
  end

  def self.json_create(o)
    b_from_json = new
    b_from_json.name = o['name']
    b_from_json.description = o['description']
    b_from_json.kind = o['kind']
    b_from_json
  end 

  def self.get_payload(widget)
    return widget.to_json
  end

end